#####HERE WE compute ANOVA for transformed Activity 
##creates tables: acttable
if(TABLEFLAG){ source("/home1/biostats/ririzarr/Clarke/make-AKR-table2.S") 
TABLEFLAG <- F;}
y <- (Act+1)^.25
I <- dim(y)[1]; J <- dim(y)[2]; K <- dim(y)[3]
ANOVA <- function(y){
m <- mean(y); y <- y-m
SS <- sum(as.vector(y)^2) 
m1 <- apply(y,1,mean) #MICE
m2 <- apply(y,2,mean) #DAY
m3 <- apply(y,3,mean); #HOUR
m12 <- apply(y,c(1,2),mean) #MOUSE + DAY
m13 <- apply(y,c(1,3),mean) #MOUSE + HOUR
m23 <- apply(y,c(2,3),mean) #Day + HOUR
M <- m1 
SSM <- J*K*sum(M^2)
D <- m2 
SSD <- I*K*sum(D^2)
f <- m3 
SSf <- I*J*sum(f^2)
MD <- sweep(m12,1,m1);MD <- sweep(MD,2,m2)
SSMD <- K*sum(MD^2)
Mf <- sweep(m13,1,m1);Mf <- sweep(Mf,2,m3)
SSMf <- J*sum(Mf^2)
Df <- sweep(m23,1,m2);Df <- sweep(Df,2,m3)
SSDf <- I*sum(Df^2)
MDf<-sweep(y,c(1,2),m12)
MDf<-sweep(MDf,c(1,3),m13)
MDf<-sweep(MDf,c(2,3),m23)
MDf<-sweep(MDf,1,m1,FUN="+")
MDf<-sweep(MDf,2,m2,FUN="+");
MDf<-sweep(MDf,3,m3,FUN="+");
SSMDf <- sum(MDf^2)
sigma2 <- SSMDf/((I-1)*(J-1)*(K-1))  
SSs <- c(SSM,SSD,SSf,SSMD,SSMf,SSDf,SSMDf,SS)
aux <- data.frame(Effect=c("M","D","f","MD","Mf","Df","MDf","Total"),
                  SS=signif(SSs/SS*100,2),
                  df=c(I-1,J-1,K-1,(I-1)*(J-1),(I-1)*(K-1),(J-1)*(K-1),
                    (I-1)*(J-1)*(K-1),I*J*K))
MSs <- SSs/aux$df
data.frame(aux,MS=signif(MSs,3))
}
 
####BOOTSTRAP ANOVA
NN <- 36
aux <- expand.grid(1:I,1:J)

cat("Activity ANOVA BOOTSTRAP:")
boot <- sapply(1:NN,function(i){
  cat(i,",",sep="")
  ij <- sample(1:(I*J)) ##re-rearange mouse,days
  yy <- array(t(apply(aux[ij,],1,function(ij) y[ij[1],ij[2],])),dim=dim(Act))
  ANOVA(yy)$MS
})
bootm <- apply(boot,1,mean)
bootsd <- sqrt((NN-1)/NN*apply(boot,1,var))

##ACTUAL ANOVA, we save this
acttable<-data.frame(ANOVA(y),BM=signif(bootm,3),BSD=signif(bootsd,3))
rm(y,boot,bootm,bootsd,NN,aux)
rm(I,J,K)

