HOME <- "/home1/biostats/ririzarr/Papers/Biometrics2000/"
###We run this after steps 3 and 4 only becuase we want to incorporate the
###correlation estimate into one of the plots made here
postscript(paste(HOME,"plot02.ps",sep=""),horizontal=F)
tt <- (0:47)/48
y <- (Act+1)^.25
m <- mean(y); y <- y-m
I <- dim(y)[1]; J <- dim(y)[2]; TT <- dim(y)[3]
m1 <- apply(y,1,mean) #MICE
m2 <- apply(y,2,mean) #DAY
m3 <- apply(y,3,mean); #HOUR
m12 <- apply(y,c(1,2),mean) #MOUSE + DAY
m13 <- apply(y,c(1,3),mean) #MOUSE + HOUR
m23 <- apply(y,c(2,3),mean) #Day + HOUR
M <- m1 
D <- m2 
f <- m3 
MD <- sweep(m12,1,m1);MD <- sweep(MD,2,m2)
Mf <- sweep(m13,1,m1);Mf <- sweep(Mf,2,m3)
MSMf <- J*sum(Mf^2)/((I-1)*(TT-1))
Df <- sweep(m23,1,m2);Df <- sweep(Df,2,m3)
MSDf <- I*sum(Df^2)/((J-1)*(TT-1))
D1 <- sum(apply(Mf,1,function(yy) sum(yy[2:TT]-yy[1:(TT-1)])^2)/(TT-1))/I/MSMf
D2 <- sum(apply(Df,1,function(yy) sum(yy[2:TT]-yy[1:(TT-1)])^2)/(TT-1))/J/MSDf
cat("For activity Df is ",round((D2-D1)/D1*100),"% rougher than Mf\n",sep="")
###WE prepare residuals to be plotted later
actres <- sweep(y,1,M)
actres <- sweep(actres,2,D)
actres <- sweep(actres,c(1,2),MD)
actres <- sweep(actres,3,f)
actres <- sweep(actres,c(1,3),Mf)

par(mfrow=c(3,2))
YLIM <- range(c(m3,as.vector(m13)))+m
plot(tt,m3+m,ylim=YLIM,type="l",xlab="Hour",ylab="Levels for each mouse",main=paste("a) Activity Mf: MS=",signif(MSMf,2)," D=",signif(D1,2),sep="")) 
for(i in 1:I)
  lines(tt,m13[i,]+m,lty=i+1)
YLIM <- range(c(m3,as.vector(m23)))+m
plot(tt,m3+m,ylim=YLIM,type="l",xlab="Hour",ylab="Levels for each day",main=paste("b) Activity Df: MS=",signif(MSDf,2)," D=",signif(D2,2),sep=""))
for(i in 1:J)
  lines(tt,m23[i,]+m,lty=i+1)

###DONE with activity plots, now to BT
tt <- (0:47)/48
y <- BT
m <- mean(y); y <- y-m
I <- dim(y)[1]; J <- dim(y)[2]; TT <- dim(y)[3]
m1 <- apply(y,1,mean) #MICE
m2 <- apply(y,2,mean) #DAY
m3 <- apply(y,3,mean); #HOUR
m12 <- apply(y,c(1,2),mean) #MOUSE + DAY
m13 <- apply(y,c(1,3),mean) #MOUSE + HOUR
m23 <- apply(y,c(2,3),mean) #Day + HOUR
M <- m1 
D <- m2 
f <- m3 
Mf <- sweep(m13,1,m1);Mf <- sweep(Mf,2,m3)
MD <- sweep(m12,1,m1);MD <- sweep(MD,2,m2)
MSMf <- J*sum(Mf^2)/((I-1)*(TT-1))
Df <- sweep(m23,1,m2);Df <- sweep(Df,2,m3)
MSDf <- I*sum(Df^2)/((J-1)*(TT-1))
D1 <- sum(apply(Mf,1,function(yy) sum(yy[2:TT]-yy[1:(TT-1)])^2)/(TT-1))/I/MSMf
D2 <- sum(apply(Df,1,function(yy) sum(yy[2:TT]-yy[1:(TT-1)])^2)/(TT-1))/J/MSDf
cat("For BT Df is ",round((D2-D1)/D1*100),"% rougher than Mf\n",sep="")
###WE prepare residuals to be plotted later
btres <- sweep(y,1,M)
btres <- sweep(btres,2,D)
btres <- sweep(btres,c(1,2),MD)
btres <- sweep(btres,3,f)
btres <- sweep(btres,c(1,3),Mf)

YLIM <- range(c(m3,as.vector(m13)))+m
plot(tt,m3+m,ylim=YLIM,type="l",xlab="Hour",ylab="Levels for each mouse",main=paste("c) BT Mf: MS=",signif(MSMf,2)," D=",signif(D1,2),sep="")) 
for(i in 1:I)
  lines(tt,m13[i,]+m,lty=i+1)
YLIM <- range(c(m3,as.vector(m23)))+m
plot(tt,m3+m,ylim=YLIM,type="l",xlab="Hour",ylab="Levels for each day",main=paste("d) BT Df: MS=",signif(MSDf,2)," D=",signif(D2,2),sep=""))
for(i in 1:J)
  lines(tt,m23[i,]+m,lty=i+1)

cov <- array(apply(actres,c(1,2),function(x) x%o%x),dim=c(TT,TT,I*J)) 
cov <- apply(cov,c(1,2),sum)/(I*J*TT - I*J - TT*I-1) ###sample covariance
cov <- cov/sqrt(diag(cov)%o%diag(cov)) ##this gives us sample corr
maxlag <- 15
plot(0:maxlag,cov[1:(maxlag+1),1],ylim=range(cov),type="n",main="e) Sample correlation for Activity",xlab="lag",ylab="Sample correlation")
for(i in 0:maxlag){
   for(j in 1:(48-i))
    points(i,cov[j,j+i])}
abline(h=0)

##now for BT
cov <- array(apply(btres,c(1,2),function(x) x%o%x),dim=c(TT,TT,I*J)) 
cov <- apply(cov,c(1,2),sum)/(I*J*TT - I*J - TT*I-1)
cov <- cov/sqrt(diag(cov)%o%diag(cov)) 
plot(0:maxlag,cov[1:(maxlag+1),1],ylim=range(cov),type="n",main="f) Sample correlation for BT",xlab="lag",ylab="Sample correlation")
for(i in 0:maxlag){
   for(j in 1:(48-i))
    points(i,cov[j,j+i])}
lines(0:maxlag,BTres$rho^(0:maxlag))
dev.off()
rm(m,I,m1,m2,m3,m12,m13,m23,M,D,f,MD,Mf,MSMf,Df,MSDf,D1,D2,btres,actres,maxlag)
rm(J,TT,YLIM,cov,tt,y)
