###THIS PROGRAM FITS using wang and browns method
## at the end the relevant information is saved in params, as, bs and alast
#delta <- 0.01 #defined in run
options(object.size=Inf)
source("/home1/biostats/ririzarr/Splus-functions/my.nls.S")
if(TABLEFLAG){source("/home1/biostats/ririzarr/Clarke/make-AKR-table2.S");TABLEFLAG <- F}
MAXITER <-1000
maxlambda <- .00000005 ##this is the biggest penalty lambda to try in the gcv
minlambda <- .0000000005
nlambda <- 60 ###this is the number of lambdas to try in [0,maxlambda]
GCV <- F##if true uses GCV otherwise uses CV
y <- (Act+1)^.25
I <- dim(BT)[1];J <- dim(BT)[2]; K <- dim(BT)[3]
Time <- c(0:(K-1))/K
f0 <- apply(y,3,mean)
f0 <- f0-mean(f0);f0 <- f0/max(abs(f0))

y <- as.vector(y)
N <- I*J*K ##length of y
 
##THis is the starting value for RSS
RSS0 <- sum((y-rep(f0,rep(I*J,K)))^2)/N
##First spline representation: a0,a1,b1,...,a23,b23,a24
##a0 is zero cause we have demeaned, assumint tau 0 and a
as <- sqrt(2)/K*sapply(1:(K/2-1),function(k) f0%*%cos(2*pi*k*(0:(K-1))/K))
bs <- sqrt(2)/K*sapply(1:(K/2-1),function(k) f0%*%sin(2*pi*k*(0:(K-1))/K))
alast <- 1/K*f0%*%cos(pi*(0:(K-1)))
 
###Now to create formula for nlfit call
aux <- sapply(1:(K/2-1),function(k) paste("as[",k,"]*cos(2*pi*",k,"*(tt-tau))+bs[",k,"]*sin(2*pi*",k,"*(tt-tau))",sep=""))
aux <- paste(aux,collapse="+")
auxcall <-formula(paste("yy~cbind(1,",aux,"+alast*cos(pi*K*(tt-tau)))",sep=""))
 
Flag <- T
while(Flag){
  cat("\nNew iteration")
  params <- apply((Act+1)^.25,1,function(yy){
    cat(".")
    yy <- as.vector(yy)
    mydata  <- data.frame(yy=yy,tt=rep((0:(K-1))/K,rep(length(yy)/K,K)))
    parameters(mydata) <- list(tau=0) 
    my.nls(auxcall,data=mydata,algorithm="plinear",control=nls.control(maxiter=MAXITER))$param
  })
###Now to recompute the splinep
  z <- (y-rep(params[2,],J*K)) ###z is the demeaned data
  aux <-data.frame(taus=as.vector(params[1,]),
		   alphas=as.vector(params[3,]),ks=(1:J)) 
  ##aux is matrix of alpha and taus and the beggings of the y for each ai,bi
  ais <- apply(as.array(aux),1,function(x){
    ##aux1 is matrix of tau,alpha and ks
    aux1 <- matrix(c(rep(x[1:2],rep((K/2-1),2)),1:(K/2-1)),ncol=3)
    ##notice z[..] is a trick to get the measurements of mice i
    z[seq(x[3],x[3]+(K*J-1)*I,J)]%*%apply(aux1,1,function(xx){
      alpha <- xx[2];tau <- xx[1];k <- xx[3]
      cos(2*pi*k*(rep(Time,rep(J,length(Time)))-tau))*sqrt(2)/K/J/alpha
    })
  }) ##ais are the I, (K/2-1) as
  ais <- rbind(ais,apply(aux,1,function(x)  z[seq(x[3],x[3]+(K*J-1)*I,J)]%*%cos(K*pi*(rep(Time,rep(J,length(Time)))-x[1]))/K/J/x[2])) ##we add alast
  bis <- apply(as.array(aux),1,function(x){ ##just like for ais
    aux1 <- matrix(c(rep(x[1:2],rep((K/2-1),2)),1:(K/2-1)),ncol=3)
    ##notice z[..] is a trick to get the measurements of mice i
    z[seq(x[3],x[3]+(K*J-1)*I,J)]%*%apply(aux1,1,function(xx){
      alpha <- xx[2];tau <- xx[1];k <- xx[3]
      sin(2*pi*k*(rep(Time,rep(J,length(Time)))-tau))*sqrt(2)/K/J/alpha
    })
  }) ##ais are the I, (K/2-1) as

	
##bis are the I*K (K/2-1) bs
  ##We try out various lambdas and choose one minimizing GCV
  ##we are using a fast way of doing this, by considering the ahats as the data
  ##see wahba page 24... the advantage is not calculating the S matrix for y
  lambdas <- seq(minlambda,maxlambda,len=nlambda)
  gcvs <- sapply(lambdas,function(lambda){
###This is what turns out to be the penalties for lambda, here m=2 wahba pg 24
    sw <- sum((aux$alphas)^2)/(I) ##this is sum of weights
    ##all we want is the trace of the S matrix for the ais,bis and this is it
    ##but the great thing is that S is diagonal!!
    ws <- c(1/(sw+lambda*(2*pi*(1:(K/2-1)))^4),1/(sw+0.5*lambda*(pi*K)^4),1/(sw+lambda*(2*pi*(1:(K/2-1)))^4)) ##these are weights
    ##To get the RSS we use wahba page 24
    as <- 1/(I)*ais%*%(aux$alphas^2)*ws[1:(K/2)]
    bs <- 1/(I)*bis%*%(aux$alphas^2)*ws[(K/2+1):(K-1)]
    ##THIS is the Average RSS divided by the trace
    if(GCV){
      Trace<-sw*sum(ws)/(I*(K-1)) #minus 1 cuase there is no mean!
      res<-sum(c(as.vector(sweep(sweep(ais,1,as),2,aux$alpha,FUN="*")),
		 as.vector(sweep(sweep(bis,1,bs),2,aux$alpha,FUN="*")))^2)/(1-Trace)^2}
      else{
	Trace<-1/(I)*as.vector(aux$alpha^2%o%ws)
	res <- sum((c(as.vector(sweep(sweep(ais,1,as),2,aux$alpha,FUN="*")),
		      as.vector(sweep(sweep(bis,1,bs),2,aux$alpha,FUN="*")))/(1-Trace))^2)
      }
    res
  })
  ##lambda minimizes the GCV
  lambda <- lambdas[order(gcvs)[1]]
  ##we prepare to contruct the new estimates of as,bs and the new f0
  sw <- sum((aux$alphas)^2)/(I) ##this is sum of weights
  ws <- c(1/(sw+lambda*(2*pi*(1:(K/2-1)))^4),1/(sw+0.5*lambda*(pi*K)^4),1/(sw+lambda*(2*pi*(1:(K/2-1)))^4)) ##these are weights
  as <- 1/(I)*ais%*%(aux$alphas^2)*ws[1:(K/2)]
  bs <- 1/(I)*bis%*%(aux$alphas^2)*ws[(K/2+1):(K-1)]
  RSS1 <- sum(c(as.vector(sweep(sweep(ais,1,as),2,aux$alpha,FUN="*")),
		as.vector(sweep(sweep(bis,1,bs),2,aux$alpha,FUN="*")))^2)/(I)
  alast <- as[K/2]
  as <- as[-(K/2)]
  ##Checking of we make a difference
  Flag <- abs(RSS1-RSS0) > delta
  RSS0 <- RSS1
  cat("|",lambda,":",RSS0,"\n")
  f0 <- cbind(sapply(1:(K/2-1),function(k) sqrt(2)*cos(2*pi*k*Time)),sapply(1:(K/2-1),function(k) sqrt(2)*sin(2*pi*k*Time)),cos(pi*K*Time))%*%c(as,bs,alast)
  normalize <- max(abs(f0))
  as <- as/normalize;bs <- bs/normalize;alast <- alast/normalize
}
		

wang <- list(params=params,as=as,bs=bs,alast=alast,lambda=lambda,f=f0)
rm(params,as,bs,alast,lambda,y,Time)
rm(Flag,GCV,I,J,K,MAXITER,N,RSS0,RSS1,ais,aux,auxcall,bis,delta,f0,gcvs,lambdas,maxlambda,minlambda,my.nls,nlambda,normalize,sw,ws,z)

