##This is like step 3 except for different data
##NN <- 3 ##these are defined in run.S
##delta <- 0.01 ###how close the paramters have to be so that we stop
options(object.size=Inf)
source("/home1/biostats/ririzarr/Clarke/make-C3B6F1-table.S")
rm(Day,HR,IDs,Week,filename,xx,yy,zz)
TABLEFLAG <- T ###we loose BT and Act
Act <- Act[,,,2]
###STARTING VALUES AND stopping criteria
sigma2 <-  0.487963#0.4243 
lambda1 <- 5.123194e-05#0.0007826 
lambda2 <- 0.1199241#0.02677 
###DEFINING DATA

I <- 3; J <- 4; TT <- 48
tt <- (0:(TT-1))/TT
n <- I*J*TT
y <-Act[1:TT,1:J,1:I]
y <- (y+1)^.25 ##BOX-COX transformation

###PREPARE MATRICES THAT we remain fixed within iterations
cat("Outside iteration Prep\n") 
Is <- 1:I;Js<-1:J
E1AUX <- apply(y,1,sum)
auxy <- apply(y,c(1,3),sum) 
E2AUX <- sapply(1:I,function(i) c(auxy[,i],apply(auxy[,-i],1,sum)))
K <- sapply(2:TT,function(k,n=TT){ 
	    p <- c(rep(1,k-1),-(k-1))
	    c(p/sqrt(sum(p^2)),rep(0,n-k))
	  })
E3AUX <- apply(expand.grid(Js,Is),1,function(ij){
  i<-ij[2];j<-ij[1]
  c(y[,j,i],
    apply(as.array(y[,Js[Js!=j],i]),1,sum),
    apply(as.array(y[,,Is[Is!=i]]),1,sum))})
###Now we construct the basis for the spline, which is used to construct the
###random effect design matrix
B <- sapply(1:(TT/2-1),function(k) sqrt(2)/(2*pi*k)^2*c(cos(2*pi*k*tt),sin(2*pi*k*tt)))
B <- matrix(as.vector(B),nrow=TT)
B <- cbind(B,1/(sqrt(2)*pi*TT)^2*cos(pi*TT*tt))
D <- c(rep(TT/(2*pi*(1:(TT/2-1)))^4,rep(2,TT/2-1)),TT/1/(sqrt(2)*pi*TT)^4)
###D is diagonal of t(B)%*%B.. notice B is orthogonal (not orthonormal)
B1 <- t(K)%*%B
FLAG <- T
while(FLAG){
  cat("Prep,")
   ###THE following matrices are used to construct V_K inverse, by inverting
  ###only matrices of size T x T. AS opposed to n x n. makes the procedure 
  ###seconds long as opposed to weeks long
  A <- 1/sigma2 ### for correlated: solve(t(K)%*%Sigma%*%K)
  N <- A*B1 
  C1 <- J/sigma2*D ##is SYMMETRIC, we use C1 cause C is a function
##for uncorrlated data, all these are diagonal so we use trick:only do
## computation with diagonals 
  G <- 1/(C1+lambda2/sigma2)
  GC1 <- G*C1
  Ei <- 1/(I*C1+lambda1/sigma2-I*C1*GC1)##is symmetric
  H <- -GC1*Ei##is SYMMETRIC
  L <- -H*GC1 ##is Symmetric, the minus is to make H into -H
  M <- G+L
  aux <- N%*%diag(2*H+Ei)%*%t(N)
  P <- - (N%*%diag(M)%*%t(N) + aux)
  O <- diag(A,TT-1) + P
  Q <- - (N%*%diag(L)%*%t(N) + aux)

  ##Now we start computing the E-part of EM
  cat("E1,")
  aux <- t(B1)%*%(O+(J-1)*P+(I-1)*J*Q)
  res <-aux%*%t(K)%*%E1AUX
  t1 <- sigma2/lambda1*(TT-1) - 
    (sigma2/lambda1)^2*I*J*sum(diag(aux%*%B1)) +
      (sigma2/lambda1)^2*sum(res^2)
  cat("E2,")
  res <- as.vector(cbind(t(B1)%*%(O+(J-1)*P)%*%t(K),t(B1)%*%(J*Q)%*%t(K))%*%E2AUX)
  t2 <- sigma2/lambda2*(TT-1)*I -
    (sigma2/lambda2)^2*I*J*sum(diag(t(B1)%*%(O+(J-1)*P)%*%B1))+
      (sigma2/lambda2)^2*sum(res^2)
  cat("E3,")
  aux <- sigma2*K
  res <- cbind(aux%*%O%*%t(K),aux%*%P%*%t(K),aux%*%Q%*%t(K))%*%E3AUX
  ##we group these residulas for each day/mouse so that we can compute 
  ##eiei-1, ei^2 etc.. easier... this is a bit inneficient but easy to program
  t0 <- n*sigma2 - sigma2^2*I*J*sum(diag(K%*%O%*%t(K))) +
    sum(as.vector(res)^2)
  sigma2new <- t0/n
  lambda1new <- sigma2new*(TT-1)/t1
  lambda2new <- sigma2new*(I*(TT-1))/t2 
  cat("Done:")
  FLAG<-abs((sigma2-sigma2new)/sigma2)+abs((lambda1-lambda1new)/lambda1) + abs((lambda2-lambda2new)/lambda2)> delta
  sigma2 <- sigma2new
  lambda1 <- lambda1new
  lambda2 <- lambda2new
  cat(signif(c(sigma2new,lambda1new,lambda2new),4),"\n")
}
cat("Finished EM!... Now to compute the estimates\n")
###notice we have re-parametrized so that Sigma doesnt contain sigma2

###NOW to compute the beta hats and u hats:
###in order to avoid creating the Sigma inverse (6000x6000) we figure out what 
###X'Sigma^{-1}X, X'Sigma^{-1} Z,... are.
## Let R be Sigma, inverse, in the case of correlated data its just I

X <- matrix(1,TT,1)
XRX <- kronecker(diag(I*J),TT)##notice that this is just TT
aux <- t(X)%*%B ##notice this is just sum(B)
XRZ <- cbind(kronecker(matrix(1,I*J,1),aux),
	     kronecker(kronecker(diag(I),matrix(1,J,1)),aux))
aux <- J*diag(D) ###remember  t(B)%*%B=D
ZRZ <- rbind(cbind(I*aux,kronecker(matrix(1,1,I),aux)),
	     cbind(kronecker(matrix(1,I,1),aux),kronecker(diag(I),aux)))
XRy <- as.vector(apply(y,c(2,3),sum))
auxy <- apply(y,c(1,3),sum) ##these are the sums of each mouse
ZRy <- c(t(B)%*%apply(y,1,sum),
	 as.vector(t(B)%*%auxy))
G <- diag(c(rep(1/lambda1,TT-1),rep(1/lambda2,I*(TT-1))))
Gi <- diag(c(rep(lambda1,TT-1),rep(lambda2,I*(TT-1))))
##
##THis can be made much more efficiently but it all takes less than 1 minute
##the efficient way, may come in handy when we bootstrap
aux <- solve(ZRZ+Gi)
aux2 <- XRZ%*%aux
betahat <- solve(XRX-aux2%*%t(XRZ))%*%(XRy-aux2%*%ZRy)
res <- sweep(y,c(2,3),matrix(betahat,J,I))
auxres <- apply(res,c(1,3),sum) 
ZRres <- c(t(B)%*%apply(res,1,sum),
	 as.vector(t(B)%*%auxres))
uhat <- aux%*%ZRres

##########   Obtaining residulas 
##########   We will use this for bootstrap

betahat <- matrix(betahat,J,I) ##these are daily means
u1hat <- uhat[1:(TT-1)] ##these are the uhats used for the overall mean
u2hat <- matrix(uhat[TT:length(uhat)],(TT-1),I) ## these uhats for mouse means

fis <- B%*%u2hat
f <- B%*%u1hat
res <- array(as.vector(apply(expand.grid(1:J,1:I),1,function(ij){
  i <- ij[2]; j <- ij[1]
  y[,j,i] - (betahat[j,i] + f + fis[,i]) ##mean + over-all + mouse
})),dim=dim(y))

##Here we save only what we need
Actres2 <- list(f=f,fis=fis,res=as.vector(res),betahat=betahat,u1hat=u1hat,u2hat=u2hat,sigma2=sigma2,lambda1=lambda1,lambda2=lambda2,B=B)


rm(f,fis,res,betahat,u1hat,u2hat,sigma2,lambda1,lambda2)
rm(X,XRX,aux,XRy,auxy,ZRy,G,Gi,aux2)
rm(A,B,B1,C1,D,E1AUX,E2AUX,E3AUX,Ei,FLAG,GC1,H,Is,Js,K,L,M,N,O,P,Q,XRZ,ZRZ,ZRres,auxres,lambda1new,lambda2new,sigma2new,t0,t1,t2,uhat,y)
cat("DONE!!!!\n") 

#############################################################################
####And now to bootstrap
#############################################################################
fs <- matrix(0,TT,NN)
params <- matrix(0,3,NN) ##this will contain sigma2,lambda1, and lamba2
for(ii in 1:NN){ ### we got laze and use a loop
  mice <- sample(1:I,size=I,replace=T) ### bootstrap sample of 12 mouse
  errors <- array(sample(Actres2$res,size=n,replace=T),dim=dim(Act))
  y <- sweep(errors,c(2,3),Actres2$betahat[,mice],FUN="+") ##adding the means
  ##here we could aslo sample day
  y <- sweep(y,c(1,3),Actres2$fis[,mice],FUN="+") ##adding mouse circadian
  y <- sweep(y,1,Actres2$f,FUN="+")
  ###STARTING VALUES AND stopping criteria
  sigma2 <-  Actres2$sigma2 ## we use these so that it goes faster
  lambda1 <- Actres2$lambda1 ## it is probably better to use some
  lambda2 <- Actres2$lambda2 ##predefined way of defining starting values
###PREPARE MATRICES THAT we remain fixed within iterations
  cat("Outside iteration Prep for bootstrap sample,",ii) 
  Is <- 1:I;Js<-1:J
  E1AUX <- apply(y,1,sum)
  auxy <- apply(y,c(1,3),sum) 
  E2AUX <- sapply(1:I,function(i) c(auxy[,i],apply(auxy[,-i],1,sum)))
  K <- sapply(2:TT,function(k,n=TT){ 
    p <- c(rep(1,k-1),-(k-1))
    c(p/sqrt(sum(p^2)),rep(0,n-k))
  })
  E3AUX <- apply(expand.grid(Js,Is),1,function(ij){
    i<-ij[2];j<-ij[1]
    c(y[,j,i],
      apply(as.array(y[,Js[Js!=j],i]),1,sum),
      apply(as.array(y[,,Is[Is!=i]]),1,sum))})
###Now we construct the basis for the spline, which is used to construct the
###random effect design matrix
  B <- sapply(1:(TT/2-1),function(k) sqrt(2)/(2*pi*k)^2*c(cos(2*pi*k*tt),sin(2*pi*k*tt)))
  B <- matrix(as.vector(B),nrow=TT)
  B <- cbind(B,1/(sqrt(2)*pi*TT)^2*cos(pi*TT*tt))
  D <- c(rep(TT/(2*pi*(1:(TT/2-1)))^4,rep(2,TT/2-1)),TT/1/(sqrt(2)*pi*TT)^4)
###D is diagonal of t(B)%*%B.. notice B is orthogonal (not orthonormal)
  B1 <- t(K)%*%B
  FLAG <- T
  cat(".. Starting EM")
  while(FLAG){
###THE following matrices are used to construct V_K inverse, by inverting
###only matrices of size T x T. AS opposed to n x n. makes the procedure 
###seconds long as opposed to weeks long
    cat(".")
    A <- 1/sigma2 ### for correlated: solve(t(K)%*%Sigma%*%K)
    N <- A*B1 
    C1 <- J/sigma2*D ##is SYMMETRIC, we use C1 cause C is a function
    ##for uncorrlated data, all these are diagonal so we use trick:only do
    ## computation with diagonals 
    G <- 1/(C1+lambda2/sigma2)
    GC1 <- G*C1
    Ei <- 1/(I*C1+lambda1/sigma2-I*C1*GC1)##is symmetric
    H <- -GC1*Ei##is SYMMETRIC
    L <- -H*GC1 ##is Symmetric, the minus is to make H into -H
    M <- G+L
    aux <- N%*%diag(2*H+Ei)%*%t(N)
    P <- - (N%*%diag(M)%*%t(N) + aux)
    O <- diag(A,TT-1) + P
    Q <- - (N%*%diag(L)%*%t(N) + aux)
    
    ##Now we start computing the E-part of EM
    aux <- t(B1)%*%(O+(J-1)*P+(I-1)*J*Q)
    res <-aux%*%t(K)%*%E1AUX
    t1 <- sigma2/lambda1*(TT-1) - 
      (sigma2/lambda1)^2*I*J*sum(diag(aux%*%B1)) +
	(sigma2/lambda1)^2*sum(res^2)
    res <- as.vector(cbind(t(B1)%*%(O+(J-1)*P)%*%t(K),t(B1)%*%(J*Q)%*%t(K))%*%E2AUX)
    t2 <- sigma2/lambda2*(TT-1)*I -
      (sigma2/lambda2)^2*I*J*sum(diag(t(B1)%*%(O+(J-1)*P)%*%B1))+
	(sigma2/lambda2)^2*sum(res^2)
    aux <- sigma2*K
    res <- cbind(aux%*%O%*%t(K),aux%*%P%*%t(K),aux%*%Q%*%t(K))%*%E3AUX
    ##we group these residulas for each day/mouse so that we can compute 
    ##eiei-1, ei^2 etc..easier... this is a bit inneficient but easy to program
    t0 <- n*sigma2 - sigma2^2*I*J*sum(diag(K%*%O%*%t(K))) +
      sum(as.vector(res)^2)
    sigma2new <- t0/n
    lambda1new <- sigma2new*(TT-1)/t1
    lambda2new <- sigma2new*(I*(TT-1))/t2 
    FLAG<-abs((sigma2-sigma2new)/sigma2)+abs((lambda1-lambda1new)/lambda1) + abs((lambda2-lambda2new)/lambda2)> delta
    sigma2 <- sigma2new
    lambda1 <- lambda1new
    lambda2 <- lambda2new
  }
  cat("Finished EM!... Now to compute the estimates\n")
  cat(signif(c(sigma2new,lambda1new,lambda2new),4),"\n")
###NOW to compute the beta hats and u hats:
###in order to avoid creating the Sigma inverse (6000x6000) we figure out what 
###X'Sigma^{-1}X, X'Sigma^{-1} Z,... are.
  ## Let R be Sigma, inverse, in the case of correlated data its just I
  X <- matrix(1,TT,1)
  XRX <- kronecker(diag(I*J),TT)##notice that this is just TT
  aux <- t(X)%*%B ##notice this is just sum(B)
  XRZ <- cbind(kronecker(matrix(1,I*J,1),aux),
	       kronecker(kronecker(diag(I),matrix(1,J,1)),aux))
  aux <- J*diag(D) ###remember  t(B)%*%B=D
  ZRZ <- rbind(cbind(I*aux,kronecker(matrix(1,1,I),aux)),
	       cbind(kronecker(matrix(1,I,1),aux),kronecker(diag(I),aux)))
  XRy <- as.vector(apply(y,c(2,3),sum))
  auxy <- apply(y,c(1,3),sum) ##these are the sums of each mouse
  ZRy <- c(t(B)%*%apply(y,1,sum),
	   as.vector(t(B)%*%auxy))
  G <- diag(c(rep(1/lambda1,TT-1),rep(1/lambda2,I*(TT-1))))
  Gi <- diag(c(rep(lambda1,TT-1),rep(lambda2,I*(TT-1))))
  ##THis can be made much more efficiently but it all takes less than 1 minute
  ##the efficient way, may come in handy when we bootstrap
  aux <- solve(ZRZ+Gi)
  aux2 <- XRZ%*%aux
  betahat <- solve(XRX-aux2%*%t(XRZ))%*%(XRy-aux2%*%ZRy)
  res <- sweep(y,c(2,3),matrix(betahat,J,I))
  auxres <- apply(res,c(1,3),sum) 
  ZRres <- c(t(B)%*%apply(res,1,sum),
	     as.vector(t(B)%*%auxres))
  uhat <- aux%*%ZRres
  u1hat <- uhat[1:(TT-1)] ##these are the uhats used for the overall mean
  fs[,ii] <- B%*%u1hat ##this is the main curve.. all we need
  params[,ii] <- c(sigma2,lambda1,lambda2)
  rm(res,betahat,u1hat,sigma2,lambda1,lambda2)
  rm(X,XRX,aux,XRy,auxy,ZRy,G,Gi,aux2)
  rm(A,B,B1,C1,D,E1AUX,E2AUX,E3AUX,Ei,FLAG,GC1,H,Is,Js,L,M,N,O,P,Q,XRZ,ZRZ,ZRres,auxres,lambda1new,lambda2new,sigma2new,t0,t1,t2,uhat,y)
}

actboot2 <- list(fs=fs,params=params,N=NN)
rm(mice,errors,params,fs)
rm(delta,I,J,K,n,NN,TT,tt)
