###HERE WE COMPUTE BOOTSTRAP "standard errors" for our curves
###Here we do it for each mouse separately so we are getting
###confidence sets for f+fi
options(object.size=Inf)
###FIrst we define D... D is the diagonal of diagonal matrix needed to compute
###distance between fs using the uhats... ||f1-f2|| = (u1-u2)'D(u1-u2)
#NN1 <- 10  ##number of bootstraps for same mouse dist
#NN2 <- 100 ##number of bootstraps for population dist
TT <- 48
D <- c(rep(TT/(2*pi*(1:(TT/2-1)))^4,rep(2,TT/2-1)),TT/1/(sqrt(2)*pi*TT)^4)

attach(Actres)
TT <- length(f); I <- dim(fis)[2]
resid <- as.vector(res)
X <- matrix(1,TT,1)
Vi <- solve(sigma2*(1/lambda1+1/lambda2)*B%*%t(B) + diag(sigma2,TT))
Hbeta <- solve(t(X)%*%Vi%*%X)%*%t(X)%*%Vi ###hat function gives us betahat=Hy
Hu <- sigma2*(1/lambda1+1/lambda2)*t(B)%*%Vi ##as above, uhat=H(y-Xbetahat)
cat(NN1,"Activity Bootstrap samples of mouse distance:")
actdist1 <- sapply(1:NN1,function(i){
  cat(i,", ",sep="")
  errors <- matrix(sample(resid,size=TT*I,replace=T),TT,I) ##bootstrap errors
  yy <- sweep(fis,1,f,FUN="+") + errors ##these is new one day data
  betastar <- Hbeta%*%yy ##these are the estiamtes of beta, betahat-star
  ustar <- Hu%*%(yy-X%*%betastar) ##similarly the star estimates of u
  aux <- sweep(u2hat,1,u1hat,FUN="+") - ustar ##this is difference between us
  apply(aux,2,function(uu) sum(D*uu^2)/TT) ##this is disance for each mouse
})

####Now the bootstrap for distance from population average
cat(NN2,"\nActivity Bootstrap samples of population distance:")
actdist2 <-  sapply(1:NN2,function(i){
  cat(i,", ",sep="")
  errors <- sample(resid,size=TT,replace=T) ##bootstrap errors
  mouse <- sample(1:I,size=1) ##bootstrap mouse
  yy <- f + fis[,mouse] + errors
  betastar <- Hbeta%*%yy ##these are the estiamtes of beta, betahat-star
  ustar <- Hu%*%(yy-X%*%betastar) ##similarly the star estimates of u
  apply(u1hat-ustar,2,function(uu) sum(D*uu^2)/TT) ##disance for population
})



detach("Actres")

###Now we repeat the procedure for Body Temperature.
##Here we dont attach... why? its a long story and not important
TT <- length(BTres$f); I <- dim(BTres$fis)[2]
X <- matrix(1,TT,1)
Sigma <- sapply(1:TT,function(k)  BTres$rho^abs((1:TT)-k))
Vi <- solve(BTres$sigma2*((1/BTres$lambda1+1/BTres$lambda2)*BTres$B%*%t(BTres$B) + Sigma))
Hbeta <- solve(t(X)%*%Vi%*%X)%*%t(X)%*%Vi ###hat function gives us betahat=Hy
Hu <- BTres$sigma2*(1/BTres$lambda1+1/BTres$lambda2)*t(BTres$B)%*%Vi 
##as above, uhat=H(y-Xbetahat)
cat(NN1,"\nBT Bootstrap samples of mouse distance:")
btdist1 <- sapply(1:NN1,function(i){
  cat(i,", ",ep="")
  ##bootstrap AR process is constructed using zi = zi-i + wni
  errors <- array(as.vector(sapply(1:I,function(i){ 
    aux <- sample(as.vector(BTres$wn[1,,]),size=1)
    wn <- sample(as.vector(BTres$wn[-1,,]),size=TT-1,replace=T)
    ##there is probably a faster way to do the following
    for(ttt in 2:TT) aux <- c(aux,BTres$rho*aux[ttt-1] + wn[ttt-1])
    aux
  })),dim=c(TT,I))
  yy <- sweep(BTres$fis,1,BTres$f,FUN="+") + errors ##these is new one day data
  betastar <- Hbeta%*%yy ##these are the estiamtes of beta, betahat-star
  ustar <- Hu%*%(yy-X%*%betastar) ##similarly the star estimates of u
  aux <- sweep(BTres$u2hat,1,BTres$u1hat,FUN="+") - ustar ##diff between us
  apply(aux,2,function(uu) sum(D*uu^2)/TT) ##this is disance for each mouse
})

####Now the bootstrap for distance from population average
cat(NN2,"\nBT Bootstrap samples of population distance:")
btdist2 <-  sapply(1:NN2,function(i){
  cat(i,", ",sep="")
  ##bootstrap AR process is constructed using zi = zi-i + wni
  errors <-  sample(as.vector(BTres$wn[1,,]),size=1)
  ##there is probably a faster way to do the following
  wn <-sample(as.vector(BTres$wn[-1,,]),size=TT-1,replace=T)
  for(ttt in 2:TT) errors <- c(errors,BTres$rho*errors[ttt-1] + wn[ttt-1])
  mouse <- sample(1:I,size=1) ##bootstrap mouse
  yy <- BTres$f + BTres$fis[,mouse] + errors
  betastar <- Hbeta%*%yy ##these are the estiamtes of beta, betahat-star
  ustar <- Hu%*%(yy-X%*%betastar) ##similarly the star estimates of u
  apply(BTres$u1hat-ustar,2,function(uu) sum(D*uu^2)/TT) ##disance for population
})


rm(Hbeta,Hu,I,NN1,NN2,TT,Vi,X,resid,D,Sigma)


