##This files computes distances and mean levels for each
##mouse, for every day data was taken
###Results are stored in ActResult
source("/home1/biostats/ririzarr/Splus-functions/my.nls.S")
if(TABLEFLAG){ source("/home1/biostats/ririzarr/Clarke/make-AKR-table2.S") 
TABLEFLAG <- F;rm(IDs,aux0)}
y <- (Act+1)^.25
m <- mean(y); y <- y-m
actmeans <- apply(y,c(1,3),mean) #MOUSE + HOUR
actmean <- apply(y,1,mean) ###Hourly mean
rm(y)
###FIrst we define D... D is the diagonal of diagonal matrix needed to compute
###distance between fs using the uhats... ||f1-f2|| = (u1-u2)'D(u1-u2)
##we also define the hat matrices that give us estimates of betahat and uhat

TT<-48
tt <- c(0:(TT-1))/TT
attach(Actres)
D <- c(rep(TT/(2*pi*(1:(TT/2-1)))^4,rep(2,TT/2-1)),TT/1/(sqrt(2)*pi*TT)^4)
X <- matrix(1,TT,1)
Vi <- solve(sigma2*(1/lambda1+1/lambda2)*B%*%t(B) + diag(sigma2,TT))
Hbeta <- solve(t(X)%*%Vi%*%X)%*%t(X)%*%Vi ###hat function gives us betahat=Hy
Hu <- sigma2*(1/lambda1+1/lambda2)*t(B)%*%Vi ##as above, uhat=H(y-Xbetahat)
detach("Actres")

###the following is used for wang and brown's algorithm
MAXITER <- 1000
f0 <- as.vector(wang$f)
K <- TT
as <- sqrt(2)/K*sapply(1:(K/2-1),function(k) f0%*%cos(2*pi*k*(0:(K-1))/K))
bs <- sqrt(2)/K*sapply(1:(K/2-1),function(k) f0%*%sin(2*pi*k*(0:(K-1))/K))
alast <- 1/K*f0%*%cos(pi*(0:(K-1)))
aux <- sapply(1:(K/2-1),function(k) paste("as[",k,"]*cos(2*pi*",k,"*(tt-tau))+bs[",k,"]*sin(2*pi*",k,"*(tt-tau))",sep=""))
aux <- paste(aux,collapse="+")
auxcall <-formula(paste("yy~cbind(1,",aux,"+alast*cos(pi*K*(tt-tau)))",sep=""))

rm(Act,BT)
source("/home1/biostats/ririzarr/Clarke/read-All-AKR-Data.S")
TABLEFLAG <- T
ActResult <- c()
IDs <- c(1:4,7:14,5:6,15:17) ##1st 12 are mice IDs considered in BR estimation
for(ii in 1:length(IDs)){ ##ii is the index in the healthy, i is index in all
  i <- IDs[ii]
  cat("\nMouse:",i,"Weeks:")
  for(j in unique(Data$WeekID[Data$ID==i])){
    cat(j)
    yy <- (Data$Act[Data$ID==i & Data$WeekID==j]+1)^.25
    tt <- Data$Hour[Data$ID==i & Data$WeekID==j]+1
    o <- (!is.na(yy) & !is.na(yy))
    yy <- yy[o]; avg <- mean(yy)
    tt <- tt[o] 
    aux <- table(tt)
    n <- min(aux)
    if(length(aux)==48 && var(yy)>0){
      yaux <- sapply(1:48,function(iii){ aux <- yy[tt==iii]; aux[1:n]})
      if(n==1) yaux <- matrix(yaux,1,48)
      ##aux is an array 48 x number of days in this weekend with 48 measurments
      ##we will fit wangs procedure, BR and the naive distance
      ds <- apply(yaux,1,function(yyy){ #ds has measurements of dist
	##notice that if ii>12 it means the mouse was not used in BR,wang...
	##first the naive distance
	if(ii>12) d1 <- sum((yyy-actmean)^2)/TT
	  else d1 <- sum((yyy - actmeans[,ii])^2)/TT
	betastar <- Hbeta%*%yyy ##estiamtes of beta, betahat-star
	ustar <- Hu%*%(yyy-X%*%betastar) ##similarly the star estimates of u
	##curve distance
	if(ii>12) d2 <- sum(D*(Actres$u1hat - ustar)^2)/TT
	  else d2 <- sum(D*(Actres$u1hat + Actres$u2hat[,ii]-ustar)^2)
	##Now we perfrom wang's algorithm
	mydata  <- data.frame(yy=yyy,tt=rep((0:(K-1))/K,rep(length(yyy)/K,K)))
	parameters(mydata) <- list(tau=0) 
	d3 <- my.nls(auxcall,data=mydata,algorithm="plinear",control=nls.control(maxiter=MAXITER))$param
	c(mean(yyy),d1,d2,d3[c(1,3)])
      })
      ##there will be n distances,one for each day in the week we have data for
      aux <- cbind(rep(i,n),rep(j,n),1:n,t(ds))
      ActResult <- rbind(ActResult,aux)
    }}}
dimnames(ActResult) <- list(NULL,c("ID","Week","Day","Avg","Naive",
				   "BR","tau","alpha"))
ActResult <- data.frame(ActResult)

rm(D,Data,Hbeta,Hu,IDs,K,MAXITER,TT,Vi,X,actmean,actmeans,alast,as,aux,auxcall,avg,bs,ds,f0,filename,i,m,my.nls,n,o,tt,y,yaux,yy)
