HOME <- "/home1/biostats/ririzarr/Papers/Biometrics2000/"
postscript(paste(HOME,"plot04.ps",sep=""),horizontal=F)
##remember there are various weeks of data, and for each week there are
##various days. usually 2.
weeksleft <- sapply(ActResult$ID,function(i) max(ActResult$Week[ActResult$ID==i]+(ActResult$Day[ActResult$ID==i]-1)/7)) - (ActResult$Week+(ActResult$Day-1)/7)
par(mfcol=c(3,2))
#######################################################
###MEAN LEVEL PLOT FOR ACTIVITY
#######################################################
meanact <- tapply(ActResult$Avg[weeksleft<15],round(weeksleft[weeksleft<15]),mean)
plot(-weeksleft[weeksleft<15],ActResult$Avg[weeksleft<15],xaxt="n",type="n",xlab="Weeks left until death",ylab="Estimated mean level",main="a) Activity")
axis(side=1,at=-unique(round(weeksleft[weeksleft<15]),labels=unique(round(weeksleft[weeksleft<15]))))
for(i in unique(ActResult$ID)){
  x <- -weeksleft[weeksleft<15 & ActResult$ID==i]
  y <- ActResult$Avg[weeksleft<15 & ActResult$ID==i]
  o <- order(x)    
  LTY <- is.element(i,c(1:4,7:12))+1 ##different lines, depending on if in IDs 
  lines(x[o],y[o],lty=LTY)
 }
lines(-as.numeric(names(meanact)),meanact,lwd=2,col=1,lty=1)
abline(h=quantile(Actres$betahat,c(.01,.99)),lty=2)
 
#######################################################
##DISTANCE PLOT
#######################################################
meanactdist <- tapply(ActResult$BR[weeksleft<15 & is.element(ActResult$ID,c(1:4,7:12))],round(weeksleft[weeksleft<15 & is.element(ActResult$ID,c(1:4,7:12))]),mean)
plot(-weeksleft[weeksleft<15],ActResult$BR[weeksleft<15],xaxt="n",type="n",xlab="Weeks left until death",ylab="Distance",main="c) Distance",log="y")
axis(side=1,at=-unique(round(weeksleft[weeksleft<15]),labels=unique(round(weeksleft[weeksleft<15]))))
for(i in unique(ActResult$ID)){
  x <- -weeksleft[weeksleft<15 & ActResult$ID==i]
  y <- ActResult$BR[weeksleft<15 & ActResult$ID==i]
  o <- order(x)    
  LTY <- is.element(i,c(1:4,7:12))+1
  lines(x[o],y[o],lty=LTY)
}
lines(-as.numeric(names(meanactdist)),meanactdist,lwd=2,col=1,lty=1)
abline(h=quantile(actdist1,c(.01,.99))) 
abline(h=quantile(actdist2,c(.01,.99)),lty=2)


#######################################################
##NAIVE DISTANCE PLOT
#######################################################
meanactndist <- tapply(ActResult$Naive[weeksleft<15 & is.element(ActResult$ID,c(1:4,7:12))],round(weeksleft[weeksleft<15 & is.element(ActResult$ID,c(1:4,7:12))]),mean)
plot(-weeksleft[weeksleft<15],ActResult$Naive[weeksleft<15],xaxt="n",type="n",xlab="Weeks left until death",ylab="Raw Distance",main="e) Raw Distance",log="y")
axis(side=1,at=-unique(round(weeksleft[weeksleft<15]),labels=unique(round(weeksleft[weeksleft<15]))))
for(i in unique(ActResult$ID)){
  x <- -weeksleft[weeksleft<15 & ActResult$ID==i]
  y <- ActResult$Naive[weeksleft<15 & ActResult$ID==i]
  o <- order(x)    
  LTY <- is.element(i,c(1:4,7:12))+1
  lines(x[o],y[o],lty=LTY)
}
lines(-as.numeric(names(meanactndist)),meanactndist,lwd=2,col=1,lty=1)


###HOUSE KEEPING
rm(x,y,IDs,LTY,aux0,filename,meanact,meanactdist,meanactndist,o,weeksleft)
##############################################################################
### NOW FOR BT PLOTS
#############################################################################

weeksleft <- sapply(BTResult$ID,function(i) max(BTResult$Week[BTResult$ID==i]+(BTResult$Day[BTResult$ID==i]-1)/7)) - (BTResult$Week+(BTResult$Day-1)/7)
#######################################################
###MEAN LEVEL PLOT FOR BOdy temperature
#######################################################
meanbt <- tapply(BTResult$Avg[weeksleft<15],round(weeksleft[weeksleft<15]),mean)
plot(-weeksleft[weeksleft<15],BTResult$Avg[weeksleft<15],xaxt="n",type="n",xlab="Weeks left until death",ylab="Estimated mean level",main="b) Body Temperature",ylim=c(35,38))
axis(side=1,at=-unique(round(weeksleft[weeksleft<15]),labels=unique(round(weeksleft[weeksleft<15]))))
for(i in unique(BTResult$ID)){
  x <- -weeksleft[weeksleft<15 & BTResult$ID==i]
  y <- BTResult$Avg[weeksleft<15 & BTResult$ID==i]
  o <- order(x)    
  LTY <- is.element(i,c(1:4,7:12))+1 ##different lines, depending on if in IDs 
  lines(x[o],y[o],lty=LTY)
 }
lines(-as.numeric(names(meanbt)),meanbt,lwd=2,col=1,lty=1)
abline(h=quantile(BTres$betahat,c(.01,.99)),lty=2)


#######################################################
##DISTANCE PLOT
#######################################################
meanbtdist <- tapply(BTResult$BR[weeksleft<15 & is.element(BTResult$ID,c(1:4,7:12))],round(weeksleft[weeksleft<15 & is.element(BTResult$ID,c(1:4,7:12))]),mean)
plot(-weeksleft[weeksleft<15],BTResult$BR[weeksleft<15],xaxt="n",type="n",xlab="Weeks left until death",ylab="Distance",main="d) Distance",log="y")
axis(side=1,at=-unique(round(weeksleft[weeksleft<15]),labels=unique(round(weeksleft[weeksleft<15]))))
for(i in unique(BTResult$ID)){
  x <- -weeksleft[weeksleft<15 & BTResult$ID==i]
  y <- BTResult$BR[weeksleft<15 & BTResult$ID==i]
  o <- order(x)    
  LTY <- is.element(i,c(1:4,7:12))+1
  lines(x[o],y[o],lty=LTY)
}
lines(-as.numeric(names(meanbtdist)),meanbtdist,lwd=2,col=1,lty=1)

abline(h=quantile(btdist1,c(.01,.99))) 
abline(h=quantile(btdist2,c(.01,.99)),lty=2)
     
#######################################################
## COMparison between distance from own circadain pattern and population
#######################################################
x <- Comparison$Week+(Comparison$Day-1)/7
plot(x,Comparison$d1,ylim=range(c(Comparison$d1,Comparison$d2)),xlab="Week",ylab="Distances",xaxt="n",type="n",log="y",main="f) Comparison")
axis(side=1,at=unique(round(x)))
lines(x,Comparison$d1,lty=2)
lines(x,Comparison$d2,lty=1)
abline(h=quantile(btdist1[,11],c(.99)),lty=2)
abline(h=quantile(btdist2,c(.99))) 
rm(x,y,IDs,LTY,aux0,filename,meanbt,meanbtdist,o,weeksleft)



dev.off()
